> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.feedonomics.com/_mcp/server. # FeedAMP Order API V2 > Event-driven order processing with enhanced control over fulfillment workflows The FeedAMP Order API V2 provides enhanced control over your order processing by allowing you to define how orders are managed, fulfilled, and updated. This event-driven system adapts to your existing processes, giving you the flexibility to automate workflows according to your specific requirements. **Use this API to:** * Authenticate and manage API access * Define events and order processes * Submit fulfillments at the item level * Process returns and refunds * Manage cancellations and refunds ## How It Works FeedAMP Order API V2 is an event-driven order processing system. Orders are imported from marketplaces on a configurable schedule, generating a new-order event. After this, your workflow configuration determines all the actions that are taken on that order. ## Authentication FeedAMP Order API V2 uses the same authentication endpoints and headers as the FeedAMP Order API v1. ## New Features Since V1 More ways to filter your incoming orders: * Optionally import orders with PENDING marketplace state * Request orders filtered by the last time status changed Additional improvements: * Submit individual item fulfillments and cancellations, instead of needing to consolidate the whole order for every submission * Invoke channel-specific operations outside of the typical FeedAMP order workflow ## Example Call Structure 1. **Get token** (only when required) * Call [GET /get_token](/developer/api-reference/rest/feed-amp-order-api-v2/authentication/get-token) with your username and password in Basic Authentication to get an auth token. * Save this token until it expires and use it in all your requests. * No more than 100 tokens can be active at any one time. 2. **Fetch orders** * **Example A:** Orders that configured workflow has determined are ready, using `feedamp_status` * Call [GET /orders?feedamp_status=IMPORTED](/developer/api-reference/rest/feed-amp-order-api-v2/orders/get-orders) * **Example B:** Orders with a particular marketplace status that have been updated since the last poll: * Call [GET /orders?normalized_marketplace_state=AWAITING_SHIPMENT\&marketplace_state_changed_after=](/developer/api-reference/rest/feed-amp-order-api-v2/orders/get-orders) `last_fetched_orders` * Your application would need to remember the timestamp `last_fetched_orders` * **Example C:** Orders in any state (including PENDING) that have recently imported * Call [GET /orders?imported_after=](/developer/api-reference/rest/feed-amp-order-api-v2/orders/get-orders) `last_fetched_orders` * Your application would need to remember the timestamp `last_fetched_orders` * API consumer must maintain their own records of order states, and fulfill orders after the `marketplace_state` changes to `AWAITING_SHIPMENT`. 3. **Confirm order** * Confirmation is how your application notifies FeedAMP that you have ingested the order. * Confirmation also allows your application to communicate its internal order identifier to FeedAMP. * Call [/orders/:order_id/confirm](/developer/api-reference/rest/feed-amp-order-api-v2/orders/confirm-order) * If feasible, include request body `{"merchant_order_number":":your_order_identifier:"}` 4. **Fulfill order lines** * Pack items and note which order lines and quantities are in each package. * Call [POST /orders/\{order_id}/fulfillments](/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/post-fulfillments) with Fulfillment model: ```json { "fulfillment_type": "shipment", "fulfillment_lines": [ { "line_id": "1", "quantity": 1 }, { "line_id": "2", "quantity": 2 } ], "shipment": { "shipped_date": "2020-01-01T12:34:56-05:00", "carrier": "UPS", "tracking_number": "1Z123XYZ" } } ``` * FeedAMP Order V2 can be configured to immediately send individual shipments to supported marketplaces. 5. **Cancel order lines** * Call [POST /orders/\{order_id}/cancellations](/developer/api-reference/rest/feed-amp-order-api-v2/cancellations/post-get-cancellations) with Cancellation model: ```json { "cancellation_lines": [ { "line_id": "3", "quantity": 3 }, { "line_id": "4", "quantity": 4 } ], "reason": "out_of_stock" } ``` * FeedAMP Order V2 can be configured to immediately send individual cancellations to supported marketplaces. 6. When all the items in the order have been fulfilled or cancelled, workflow can be configured to send whole-order fulfillment to supported marketplaces. ## Additional Notes * All date-time fields use RFC 3339 formatting, including time zone: `1999-12-31T23:59:59-05:00` * It is expected that REST API integrations are able to tolerate additive (i.e. non-breaking) updates without requiring advance notice. > Documentation for Feedonomics — the enterprise product feed management platform ## Docs - [FeedAMP Order API V2](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2.md): Event-driven order processing with enhanced control over fulfillment workflows ## API Docs - API Reference > Authentication [Get an authentication token](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/authentication/get-token.md) - API Reference > Orders [Get orders filtered by search parameters](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/orders/get-orders.md) - API Reference > Orders [Get order by {order-id}](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/orders/get-order.md) - API Reference > Orders [Confirm receipt of order and update merchant order number](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/orders/confirm-order.md) - API Reference > Orders [Run an operation on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/orders/run-order-op.md) - API Reference > Fulfillment Requests [Get fulfillment requests filtered by search parameters](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillment-requests/get-fulfillment-requests.md) - API Reference > Fulfillment Requests [Get fulfillment requests by order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillment-requests/get-order-fulfillment-requests.md) - API Reference > Fulfillment Requests [Get details of a single fulfillment request](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillment-requests/get-order-fulfillment-request.md) - API Reference > Fulfillments [List fulfillments on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/get-fulfillments.md) - API Reference > Fulfillments [Create a fulfillment on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/post-fulfillments.md) - API Reference > Fulfillments [Get details of a single fulfillment](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/get-fulfillment.md) - API Reference > Fulfillments [Update details of a fulfillment](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/put-fulfillment.md) - API Reference > Fulfillments [Delete a fulfillment](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/fulfillments/del-fulfillment.md) - API Reference > Cancellations [List all cancellations on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/cancellations/get-cancellations.md) - API Reference > Cancellations [Create a cancellation on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/cancellations/post-get-cancellations.md) - API Reference > Cancellations [Get details of a single cancellation](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/cancellations/get-cancellation.md) - API Reference > Cancellations [Update details of a cancellation](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/cancellations/put-cancellation.md) - API Reference > Cancellations [Delete a cancellation](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/cancellations/del-cancellation.md) - API Reference > Refunds [List all refunds on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/refunds/get-refunds.md) - API Reference > Refunds [Create a refund adjustment on an order](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/refunds/post-order-refund.md) - API Reference > Refunds [Get details of a single refund](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/refunds/get-refund.md) - API Reference > Refunds [Apply a refund on an return](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/refunds/post-return-refund.md) - API Reference > Returns [Get returns filtered by search parameters](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/returns/get-returns.md) - API Reference > Returns [Get an individual return](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/returns/get-return.md) - API Reference > Returns [Run an operation on an return](https://docs.feedonomics.com/developer/api-reference/rest/feed-amp-order-api-v2/returns/run-return-op.md) ## OpenAPI Specification The raw OpenAPI 3.1 specification for this API is available at: - [OpenAPI JSON](https://docs.feedonomics.com/openapi.json) - [OpenAPI YAML](https://docs.feedonomics.com/openapi.yaml)